require_relative './errors.rb'

module Services
  module Config
    module Errors
      class Parser < StandardError
        attr_reader :last_called_method

        def initialize(msg = "Something went wrong", last_called_method = '#init')
          @last_called_method = last_called_method
          super(msg)
        end
      end

      class InvalidConfig < Parser
        attr_reader :last_called_method

        def initialize(msg, last_called_method)
          super(msg, last_called_method)
        end
      end
    end
  end
end
