require_relative './config.rb'
require_relative './errors/parser.rb'
require 'yaml'

module Services
  module Config
    class Parser
      attr_reader :config_path, :config_structs

      def initialize(config_path = Services::Config::DEFAULT_CONFIG_PATH)
        @config_path = config_path
        @config_hash = YAML.load_file(@config_path)
        @config_structs = nil
      end

      def load_config
        begin
          @config_structs = @config_structs.nil? ? Services::Config::ConfigStruct.new(@config_hash) : @config_structs
        rescue StandardError => e
          throw Services::Config::Errors::InvalidConfig.new(e.message, '#load_config')
        end
      end
    end
  end
end
