require_relative '../services.rb'
require_relative '../rabbit_wrapper/base.rb'
require_relative '../rabbit_wrapper/from_config.rb'
require_relative '../config/parser.rb'

module Services
  module PublicApi
    def self.default_proc(body, rabbit_wrapper)
      puts "
        No proc given but received this msg: #{body} \n
        With this instance of rabbit: #{rabbit_wrapper}

        Pass a proc to CultivatedRabbit.load_from_config(sub_proc: Proc.new { |body, rabbit_wrapper| your logic })
      "
      rabbit_wrapper.publish('Hello World')
    end

    # returns a rabbit class from config file
    def self.load_from_config(config_path: '', sub_proc: nil)
      config = Services::Config::Parser.new(config_path)
      proc_default = proc { |body, rabbit| default_proc(body, rabbit) }

      Services::RabbitWrapper::FromConfig.run(config: config, sub_proc: sub_proc.nil? ? proc_default : sub_proc)
    end

    # returns a rabbit_wrapper class reference with no config
    def self.rabbit_wrapper
      Services::RabbitWrapper::Base
    end

    # internal logs, to be implemented
    def self.logs
      raise NotImplementedError
    end
  end
end
